; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include traklog.inc       ; local includes for this file

      RichEdMl      PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
      settingsProc  PROTO :DWORD,:DWORD,:DWORD,:DWORD 
      sedit1Proc    PROTO :DWORD,:DWORD,:DWORD,:DWORD 
      AboutProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD 
      ftrim         PROTO :DWORD

    .data?
      hEdit dd ?
      interval dd ?
      hTimer dd ?
      filelen dd ?
      logbuffer db 260 dup (?)
      bsiz1 dd ?
      bsiz2 dd ?
      freq dd ?
      sbutn1 dd ?
      sbutn2 dd ?
      sedit1 dd ?
      sedit2 dd ?
      lpsedit1Proc dd ?
      pini dd ?
      ini_name db 260 dup (?)
      isSet dd ?
      isFile dd ?

.code

start:

; 

      invoke InitCommonControls

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   FUNC(GetModuleHandle, NULL)
      mov CommandLine, FUNC(GetCommandLine)
      mov hIcon,       FUNC(LoadIcon,hInstance,500)
      mov hCursor,     FUNC(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        FUNC(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        FUNC(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"traklog_Class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

  ; -------------------------------------------------
  ; macro to autoscale window co-ordinates to screen
  ; percentages and centre window at those sizes.
  ; -------------------------------------------------
    AutoScale 75, 70

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayMenu hWnd,600
    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        NULL

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    push esi
    push edi
    xor edi, edi                        ; clear EDI
    lea esi, msg                        ; Structure address in ESI
    jmp jumpin

    StartLoop:
      invoke TranslateMessage, esi
    ; --------------------------------------
    ; perform any required key processing here
    ; --------------------------------------
      invoke DispatchMessage,  esi
    jumpin:
      invoke GetMessage,esi,edi,edi,edi
      test eax, eax
      jnz StartLoop

    mov eax, msg.wParam
    pop edi
    pop esi

    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL fname  :DWORD
    LOCAL patn   :DWORD
    LOCAL tbh    :DWORD
    LOCAL sbh    :DWORD
    LOCAL hIni   :DWORD
    LOCAL pbuf   :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[260]:BYTE  ; these are two spare buffers
    LOCAL buffer2[260]:BYTE  ; for text manipulation etc..
    LOCAL hFile :DWORD
    LOCAL hMem  :DWORD
    LOCAL pMem  :DWORD
    LOCAL bWritten:DWORD
    LOCAL cloc  :DWORD
    LOCAL cr    :CHARRANGE
    LOCAL flen2 :DWORD

    Switch uMsg
      Case WM_TIMER
        mov pbuf, ptr$(buffer1)
        invoke GetTimeFormat,LOCALE_USER_DEFAULT,NULL,NULL,NULL,pbuf,260
        invoke SendMessage,hStatus,SB_SETTEXT,0,pbuf

        invoke filesize,OFFSET logbuffer                    ; get file size from file system

        .if filelen != eax                                  ; if file size has changed
          mov filelen, eax                                  ; save new size in global
          mov flen2, eax                                    ; copy it to a local
          add flen2, 1                                      ; add 1 for terminator
          fn SendMessage,hStatus,SB_SETTEXT,1,str$(flen2)
          mov eax, OFFSET logbuffer
          cmp BYTE PTR [eax], 0
          je nofile

          invoke CreateFile,OFFSET logbuffer,GENERIC_READ,
                            FILE_SHARE_WRITE or FILE_SHARE_READ,
                            NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL or \
                            FILE_FLAG_POSIX_SEMANTICS,NULL
          mov hFile, eax

          mov eax, bsiz1
          .if flen2 < eax
            mov hMem, alloc(flen2)
            mov bWritten, fread(hFile,hMem,flen2)
            mov pMem, rv(ftrim,hMem)
            invoke SetWindowText,hEdit,pMem
            invoke GetWindowTextLength,hEdit
            mov cr.cpMin, eax
            mov cr.cpMax, eax
            invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR cr
            free hMem
          .else
            mov hMem, alloc(bsiz1)
            invoke SetFilePointer,hFile,bsiz2,0,FILE_END
            mov bWritten, fread(hFile,hMem,bsiz1)
            mov pMem, rv(ftrim,hMem)
            invoke SetWindowText,hEdit,pMem
            invoke GetWindowTextLength,hEdit
            mov cr.cpMin, eax
            mov cr.cpMax, eax
            invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR cr
            free hMem
          .endif

          fclose hFile

        .endif

        nofile:

      Case WM_COMMAND
        Switch wParam
        ;======== toolbar commands ========
          Case 50
            jmp menu_open
          Case 51
            jmp menu_start
          Case 52
            jmp menu_stop
          Case 53
            jmp menu_close

        ;======== menu commands ========
          Case 1001
            menu_open:
            sas patn, "All files",0,"*.*",0
            mov fname, OpenFileDlg(hWin,hInstance,"Select File To Track",patn)
            cmp BYTE PTR [eax], 0
            jne @F
            return 0
            @@:
          ; ------------------------
          ; copy file name to global
          ; ------------------------
            invoke szCopy,fname,OFFSET logbuffer
            invoke SendMessage,hStatus,SB_SETTEXT,3,OFFSET logbuffer

            mov filelen, rv(filesize,OFFSET logbuffer)
            fn SendMessage,hStatus,SB_SETTEXT,1,str$(filelen)

            .if isSet == 0
              fn SendMessage,hStatus,SB_SETTEXT,2,"Stopped"
            .else
              fn SendMessage,hStatus,SB_SETTEXT,2,"Tracking"
            .endif

            invoke CreateFile,OFFSET logbuffer,GENERIC_READ,
                              FILE_SHARE_WRITE or FILE_SHARE_READ,
                              NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL or \
                              FILE_FLAG_POSIX_SEMANTICS,NULL
            mov hFile, eax

            mov isFile, 1           ; set the file flag

            mov eax, bsiz1
          .if filelen < eax
            mov hMem, alloc(filelen)
            mov bWritten, fread(hFile,hMem,filelen)
            mov pMem, rv(ftrim,hMem)
            invoke SetWindowText,hEdit,pMem
            invoke GetWindowTextLength,hEdit
            mov cr.cpMin, eax
            mov cr.cpMax, eax
            invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR cr
            free hMem
          .else
            mov hMem, alloc(bsiz1)
            invoke SetFilePointer,hFile,bsiz2,0,FILE_END
            mov bWritten, fread(hFile,hMem,bsiz1)
            mov pMem, rv(ftrim,hMem)
            invoke SetWindowText,hEdit,pMem
            invoke GetWindowTextLength,hEdit
            mov cr.cpMin, eax
            mov cr.cpMax, eax
            invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR cr
            free hMem
          .endif

          invoke SendMessage,hToolBar,TB_ENABLEBUTTON,51,TRUE

          fclose hFile

          Case 1002
            menu_start:
            .if isFile != 0
              mov hTimer, rv(SetTimer,hWnd,9999,interval,NULL)
              fn SendMessage,hStatus,SB_SETTEXT,2,"Tracking"
              mov isSet, 1
              invoke SendMessage,hToolBar,TB_ENABLEBUTTON,51,FALSE
              invoke SendMessage,hToolBar,TB_ENABLEBUTTON,52,TRUE
            .endif

          Case 1003
            menu_stop:
            .if isFile != 0
              invoke KillTimer,hWnd,hTimer
              fn SendMessage,hStatus,SB_SETTEXT,2,"Stopped"
              mov isSet, 0
              invoke SendMessage,hToolBar,TB_ENABLEBUTTON,51,TRUE
              invoke SendMessage,hToolBar,TB_ENABLEBUTTON,52,FALSE
            .endif

          case 1004
            invoke DialogBoxParam,hInstance,150,hWin,ADDR settingsProc,0

          Case 1010
            menu_close:
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL

          Case 1900

            invoke DialogBoxParam,hInstance,160,hWin,ADDR AboutProc,0

          ;====== end menu commands ======
      Endsw

      Case WM_CREATE

        mov isSet, 0
        mov isFile, 0       ; clear the file loaded flag at startup.

        mov pini, OFFSET ini_name
        invoke GetModuleFileName,NULL,pini,260
        invoke GetPathOnly,pini,pini
        mov pini, cat$(pini,"tlog.ini")     ; address of complete INI file and path

        fn SendMessage,hStatus,SB_SETTEXT,2,"Stopped"

        szText ReDLL,"RICHED32.DLL"
        invoke LoadLibrary,ADDR ReDLL
        invoke RichEdMl,200,90,250,200,hWin,800
        mov hEdit, eax
        invoke GetStockObject,SYSTEM_FIXED_FONT
        invoke SendMessage,hEdit,WM_SETFONT,eax,0
        invoke SendMessage,hEdit,EM_EXLIMITTEXT,0,400000000

        invoke Do_ToolBar,hWin
        invoke Do_Status,hWin

        mov logbuffer[0], 0

      ; ----------------------------------
      ; either create or read the INI file
      ; ----------------------------------
        .if rv(exist,pini) == 0
          mov hIni, fcreate(pini)           ; create INI if it does not exist
          fprint hIni,"4096"
          fprint hIni,"50"
          fclose hIni
          mov bsiz1, 4096
          mov eax, bsiz1
          neg eax
          add eax, 1
          mov bsiz2, eax
          mov freq, 50
        .else
          mov hIni, InputFile(pini)         ; else read the existing INI file
          mov pbuf, ptr$(buffer1)
          mov edx, linein$(hIni,pbuf,0)
          push edx
          mov bsiz1, sval(pbuf)
          mov eax, bsiz1
          neg eax
          add eax, 1
          mov bsiz2, eax
          pop edx
          mov edx, linein$(hIni,pbuf,edx)
          mov freq, sval(pbuf)
          free hIni
        .endif

        invoke SendMessage,hToolBar,TB_ENABLEBUTTON,51,FALSE
        invoke SendMessage,hToolBar,TB_ENABLEBUTTON,52,FALSE

      Case WM_SYSCOLORCHANGE
        invoke Do_ToolBar,hWin

      Case WM_SIZE
        invoke SendMessage,hToolBar,TB_AUTOSIZE,0,0
        invoke MoveWindow,hStatus,0,0,0,0,TRUE

        invoke GetClientRect,hToolBar,ADDR Rct
        mov eax, Rct.bottom
        mov tbh, eax
        add tbh, 2

        invoke GetClientRect,hStatus,ADDR Rct
        mov eax, Rct.bottom
        mov sbh, eax

        invoke GetClientRect,hWin,ADDR Rct

        mov eax, tbh
        sub Rct.bottom, eax
        mov eax, sbh
        sub Rct.bottom, eax

      ; --------------------------------------------------------------------
      ; Use a valid handle in the following MoveWindow() call and uncomment
      ; --------------------------------------------------------------------
        invoke MoveWindow,hEdit,0,tbh,Rct.right,Rct.bottom,TRUE

      Case WM_CLOSE
        invoke KillTimer,hWin,hTimer
        fclose hFile

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

      case WM_SETFOCUS
        invoke SetFocus,hEdit

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

TopXY proc wDim:DWORD, sDim:DWORD

    mov eax, [esp+8]
    sub eax, [esp+4]
    shr eax, 1

    ret 8

TopXY endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

RichEdMl proc a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,hParent:DWORD,ID:DWORD

    fn CreateWindowEx,WS_EX_STATICEDGE,"RICHEDIT",0, \
                      WS_VISIBLE or WS_CHILDWINDOW or \
                      ES_MULTILINE or WS_VSCROLL or WS_HSCROLL or \
                      ES_AUTOHSCROLL or ES_AUTOVSCROLL or ES_NOHIDESEL, \
                      a,b,wd,ht,hParent,ID,hInstance,NULL
    ret

RichEdMl endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

ftrim proc ptxt:DWORD

    mov eax, [esp+4]
    sub eax, 1

  @@:
    add eax, 1
    cmp BYTE PTR [eax], 0
    je @F
    cmp BYTE PTR [eax], 10
    jne @B
    add eax, 1
  @@:
    ret 4

ftrim endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

settingsProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    LOCAL pbuf1 :DWORD
    LOCAL pbuf2 :DWORD
    LOCAL hIni  :DWORD
    LOCAL buffer1[64]:BYTE
    LOCAL buffer2[64]:BYTE

    .if uMsg == WM_INITDIALOG
      invoke SendMessage,hWin,WM_SETICON,1,hIcon

      mov sbutn1, rv(GetDlgItem,hWin,IDOK)      ;; OK
      mov sbutn2, rv(GetDlgItem,hWin,IDCANCEL)  ;; CANCEL
      mov sedit1, rv(GetDlgItem,hWin,103)       ;; Buffer size
      mov sedit2, rv(GetDlgItem,hWin,104)       ;; Interval

      invoke SetWindowLong,sedit1,GWL_WNDPROC,sedit1Proc
      invoke SetWindowLong,sedit2,GWL_WNDPROC,sedit1Proc
      mov lpsedit1Proc, eax

      mov hIni, InputFile(pini)

      mov pbuf1, ptr$(buffer1)
      mov edx, linein$(hIni,pbuf1,0)
      push edx
      invoke SetWindowText,sedit1,pbuf1

      mov pbuf1, ptr$(buffer1)
      pop edx
      mov edx, linein$(hIni,pbuf1,edx)

      invoke SetWindowText,sedit2,pbuf1

      free hIni

    ; -------------------------------------
    ; return 1 to set focus to 1st control
    ; -------------------------------------
      mov eax, 1
      ret

    .elseif uMsg == WM_COMMAND
      .if wParam == IDOK
        .if rv(GetWindowTextLength,sedit1) == 0
          fn MessageBox,hWnd,"Please set the buffer size", \
                             "Buffer Size Setting",MB_OK
          invoke SetFocus,sedit1
          ret
        .endif

        .if rv(GetWindowTextLength,sedit2) == 0
          fn MessageBox,hWnd,"Please set the interval duration", \
                             "Interval Duration Setting",MB_OK
          invoke SetFocus,sedit2
          ret
        .endif

          mov pbuf1, ptr$(buffer1)
          mov pbuf2, ptr$(buffer2)

          invoke GetWindowText,sedit1,pbuf1,64
          invoke GetWindowText,sedit2,pbuf2,64

          mov hIni, fcreate(pini)
          fprint hIni,pbuf1
          fprint hIni,pbuf2
          fclose hIni

          mov bsiz1, sval(pbuf1)            ; if 4096
          mov eax, bsiz1
          neg eax
          add eax, 1
          mov bsiz2, eax                    ; becomes -4095
          mov interval, sval(pbuf2)

          .if isSet != 0
            invoke KillTimer,hWnd,hTimer
            mov hTimer, rv(SetTimer,hWnd,9999,interval,NULL)
          .endif

          jmp quit_dialog

      .elseif wParam == IDCANCEL
        jmp quit_dialog
      .endif

    .elseif uMsg == WM_CLOSE
      quit_dialog:
       invoke EndDialog,hWin,0

    .endif

    ; -------------------------------
    ; return zero for default action
    ; -------------------------------
    xor eax, eax
    ret

settingsProc endp

; 

sedit1Proc proc hCtl:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg == WM_CHAR
      .if wParam == 8
        jmp bspc
      .endif

      .if wParam < 48 || wParam > 57
        ret
      .endif

    bspc:

    .endif

    invoke CallWindowProc,lpsedit1Proc,hCtl,uMsg,wParam,lParam

    ret

sedit1Proc endp

; 

AboutProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    switch uMsg
      case WM_COMMAND
        .if wParam == IDOK
          jmp quit_dialog
        .endif

    case WM_CLOSE
      quit_dialog:
       invoke EndDialog,hWin,0

    endsw

    xor eax, eax
    ret

AboutProc endp

; 

end start
